tigase.jaxmpp.core.client.xmpp.modules.omemo

## Class OmemoModule

- java.lang.Object
- - tigase.jaxmpp.core.client.xmpp.modules.omemo.OmemoModule

- All Implemented Interfaces:
    ContextAware, InitializingModule, XmppModule

      public class OmemoModule
      extends Object
      implements XmppModule, ContextAware, InitializingModule

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `OmemoModule.CipherFactory`
    `static interface` | `OmemoModule.CreateOMEMOSessionHandler`
    `static interface` | `OmemoModule.KeysRetrieverHandler`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `AUTOCREATE_OMEMO_SESSION`
    `static String` | `DEVICELIST_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OmemoModule()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterRegister()` Called when module is registered.
    `void` | `beforeRegister()` Called just before registration module in XmppModulesManager .
    `void` | `beforeUnregister()` Called when module is unregistered.
    `XmppOMEMOSession` | `createOMEMOSession(BareJID jid)`
    `void` | `createOMEMOSession(BareJID jid, OmemoModule.CreateOMEMOSessionHandler handler)`
    `Criteria` | `getCriteria()` Criteria
    `OmemoModule.CipherFactory` | `getCustomCipherFactory()`
    `Extension` | `getExtension()`
    `String[]` | `getFeatures()` Returns features what are implemented by Module.
    `void` | `getKeys(BareJID jid, OmemoModule.KeysRetrieverHandler handler)`
    `XmppOMEMOSession` | `getOMEMOSession(BareJID jid)`
    `XmppOMEMOSession` | `getOMEMOSession(BareJID jid, boolean createIfNotExists)`
    `static JaXMPPSignalProtocolStore` | `getSignalProtocolStore(SessionObject sessionObject)`
    `boolean` | `isOMEMORequired(BareJID jid)`
    `void` | `process(Element element)` Main method of module.
    `void` | `publishDeviceList()`
    `void` | `setContext(Context context)`
    `void` | `setCustomCipherFactory(OmemoModule.CipherFactory customCipherFactory)`
    `static void` | `setSignalProtocolStore(SessionObject sessionObject, JaXMPPSignalProtocolStore store)`
    `void` | `subscribeForDeviceList(BareJID jid)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEVICELIST_NODE

          public static final String DEVICELIST_NODE

      See Also:
        Constant Field Values

    - #### AUTOCREATE_OMEMO_SESSION

          public static final String AUTOCREATE_OMEMO_SESSION

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OmemoModule

          public OmemoModule()

  - ### Method Detail

    - #### getSignalProtocolStore

          public static JaXMPPSignalProtocolStore getSignalProtocolStore(SessionObject sessionObject)

    - #### setSignalProtocolStore

          public static void setSignalProtocolStore(SessionObject sessionObject,
                                                    JaXMPPSignalProtocolStore store)

    - #### afterRegister

          public void afterRegister()

      Description copied from interface: `InitializingModule`
      Called when module is registered. At this moment module is formally registered and it is part of client.
      Specified by:
        `afterRegister` in interface `InitializingModule`

    - #### beforeRegister

          public void beforeRegister()

      Description copied from interface: `InitializingModule`
      Called just before registration module in XmppModulesManager . It is good place to check if module is initialized properly.
      Specified by:
        `beforeRegister` in interface `InitializingModule`

    - #### beforeUnregister

          public void beforeUnregister()

      Description copied from interface: `InitializingModule`
      Called when module is unregistered.
      Specified by:
        `beforeUnregister` in interface `InitializingModule`

    - #### createOMEMOSession

          public XmppOMEMOSession createOMEMOSession(BareJID jid)

    - #### createOMEMOSession

          public void createOMEMOSession(BareJID jid,
                                         OmemoModule.CreateOMEMOSessionHandler handler)
                                  throws JaxmppException

      Throws:
        `JaxmppException`

    - #### getCriteria

          public Criteria getCriteria()

      Description copied from interface: `XmppModule`
      Criteria
      Specified by:
        `getCriteria` in interface `XmppModule`
      Returns:

    - #### getCustomCipherFactory

          public OmemoModule.CipherFactory getCustomCipherFactory()

    - #### setCustomCipherFactory

          public void setCustomCipherFactory(OmemoModule.CipherFactory customCipherFactory)

    - #### getExtension

          public Extension getExtension()

    - #### getFeatures

          public String[] getFeatures()

      Description copied from interface: `XmppModule`

      Returns features what are implemented by Module.

      See Service Discovery Features

      Specified by:
        `getFeatures` in interface `XmppModule`
      Returns:
        array of features

    - #### getKeys

          public void getKeys(BareJID jid,
                              OmemoModule.KeysRetrieverHandler handler)
                       throws JaxmppException

      Throws:
        `JaxmppException`

    - #### getOMEMOSession

          public XmppOMEMOSession getOMEMOSession(BareJID jid)

    - #### getOMEMOSession

          public XmppOMEMOSession getOMEMOSession(BareJID jid,
                                                  boolean createIfNotExists)

    - #### isOMEMORequired

          public boolean isOMEMORequired(BareJID jid)

    - #### process

          public void process(Element element)
                       throws JaxmppException

      Description copied from interface: `XmppModule`
      Main method of module. Module will process incoming stanza by call this method.
      Specified by:
        `process` in interface `XmppModule`
      Parameters:
        `element` - incoming XMPP stanza
      Throws:
        `JaxmppException`

    - #### publishDeviceList

          public void publishDeviceList()
                                 throws JaxmppException

      Throws:
        `JaxmppException`

    - #### setContext

          public void setContext(Context context)

      Specified by:
        `setContext` in interface `ContextAware`

    - #### subscribeForDeviceList

          public void subscribeForDeviceList(BareJID jid)
                                      throws JaxmppException

      Throws:
        `JaxmppException`

Copyright © 2006–2023 Tigase. All rights reserved.